#define Clouds
#define CloudAmount 11.0 //[13.0 12.0 11.0 10.0 9.0]
#define CloudHeight 16.0 //[8.0 12.0 16.0 20.0 24.0]
#define CloudOpacity 1.0 //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0]

#ifdef Clouds
vec3 drawCloud(vec3 fposition, float dither, vec3 color, vec3 light, vec3 ambient) {
	float totalcloud = 0;
	vec3 sVector = normalize(fposition);
	float cosT = dot(sVector,upVec);
	float cosS = dot(sunVec,sVector);
	float pi = 3.1415927;
	vec2 wind = vec2(frametime,0.0)*0.001;

	vec3 tpos = vec3(gbufferModelViewInverse * vec4(fposition,1.0));
	vec3 wVector = normalize(tpos);

	float cloud = 0.0;
	vec3 cloud_color = vec3(0.0);
	float colmix = 0.0;
	float colmult = 0.5*(1.0-moonVisibility*0.7)*(1.0-wetness*(0.8-0.4*sunVisibility))*(2.0-eBS)*(1.0+nightVision);

	if (cosT > 0.05){
		vec3 intersection = wVector*(CloudHeight*2.5/wVector.y);
		vec2 coord = (intersection.xz + cameraPosition.xz*0.125)*0.002;
		coord += (texture2D(noisetex,coord.xy*2.0).xy*2.0-1.0)*0.0003;
		
		cloud+= texture2D(noisetex,coord*0.5+wind*3.2).x*4;
		cloud+= texture2D(noisetex,coord*0.25+wind*1.6).x*8;
		cloud+= texture2D(noisetex,coord*0.125+wind*0.8).x*16;
		cloud+= texture2D(noisetex,coord*0.0625+wind*0.4).x*32;
		cloud+= texture2D(noisetex,coord*0.03125+wind*0.2).x*64;
		cloud = mix(cloud,124.0,0.7*wetness)*min(sqrt(cosT*6.0),1.0);
		
		cloud = pow(cloud/124.0,12.0);
		cloud /= 1.0+3.0*cloud;
		cloud *= clamp(cosT*5.0-1.0,0.0,1.0)*(1.0-0.7*wetness*wetness);
	}
	
	return color+cloud*light*colmult*CloudOpacity;
}
#else
vec3 drawCloud(vec3 fposition, float dither, vec3 color, vec3 light, vec3 ambient) {
return color;
}
#endif